(* W13 *)
(* merge 'a list -> 'a list -> 'a list *)
let rec merge xs ys = match (xs,ys) with
 | ([],ys) -> ys
 | (xs,[]) -> xs
 | (x::xs,y::ys) -> if x < y then x::(merge xs (y::ys))
                             else y::(merge (x::xs) ys)
(* msort 'a list -> 'a list *)
let rec msort = function
 | [] -> []
 | [z] -> [z]
 | zs -> let (xs,ys) = Lst.split_at (Lst.length zs / 2) zs in
         merge (msort xs) (msort ys)
