
(* fib : int -> int *)
let rec fib n = if n < 2 then 1 else fib(n-1) + fib(n-2)

(* fibpair : int -> int * int *)
let rec fibpair n = if n < 1 then (0,1) else (
 if n = 1 then (1,1)
          else let (f1,f2) = fibpair (n-1) in (f2,f1+f2)
)

(* fibpair_tl : int -> int * int *)
let fibpair_tl n =
 let rec fibpair f1 f2 n =
  if n < 1 then (f1, f2)
           else fibpair f2 (f1 + f2) (n - 1)
 in fibpair 0 1 n

(* E08 *) 
(* W13 *) 
(* fib_dp : int -> int *)
let fib_dp n = 
 let rec fib t n = 
  if Lookup.mem t n then t
  else if n < 2 then Lookup.add t n 1
  else 
   let t = fib t (n-1) in
   let t = fib t (n-2) in
   let r = Lookup.find t (n-1) + Lookup.find t (n-2) in
   let t = Lookup.add t n r in
   t
 in Lookup.find (fib Lookup.empty n) n
